#include <QtGui>
#include <QtWidgets>

static QDrag* pCurrentDrag = nullptr;

class Giver : public QTextEdit
{
private:
    QPoint m_ptDragPos;
    QPixmap dragCursor;

protected:
    virtual void dragEnterEvent(QDragEnterEvent *e)
    {
        e->acceptProposedAction();
    }

    void dragLeaveEvent(QDragLeaveEvent *)
    {
    }

    virtual void mousePressEvent(QMouseEvent *)
    {
        QMimeData* pMimeData = new QMimeData;
        pMimeData->setText(toPlainText());
        QDrag* pDrag = new QDrag(this);
        pCurrentDrag = pDrag;

        pDrag->setMimeData(pMimeData);
        pDrag->setDragCursor(dragCursor, Qt::MoveAction);
        pDrag->exec(Qt::MoveAction);
    }

public:
    Giver(QWidget* pwgt = 0) : QTextEdit("NewText", pwgt)
    {
        setAcceptDrops(true);
        Q_ASSERT(dragCursor.load("picture.jpg"));
	}
};

class Getter : public QLabel
{
	QPixmap dropCursor;
    QPixmap originalPixmap;
public:
    Getter(QWidget* pwgt = 0) : QLabel("oldText", pwgt)
    {
        setAcceptDrops(true);
		Q_ASSERT(dropCursor.load("picture2.jpg"));
    }

protected:
    virtual void dragEnterEvent(QDragEnterEvent* pe)
    {
        originalPixmap = pCurrentDrag->dragCursor(Qt::MoveAction);
		pCurrentDrag->setDragCursor(dropCursor, Qt::MoveAction);
		pe->acceptProposedAction();
    }

    virtual void dropEvent(QDropEvent* pe)
    {
        setText(pe->mimeData()->text());
    }

    void dragLeaveEvent(QDragLeaveEvent *)
    {
        pCurrentDrag->setDragCursor(originalPixmap, Qt::MoveAction);
    }
};

int main(int argc, char *argv[])
{
    QApplication a(argc, argv);

    QCursor cursor(QPixmap("img.png"));
    QGuiApplication::setOverrideCursor(cursor);

    Giver giver;
    Getter getter;

    giver.resize(100, 100);
    getter.resize(100, 100);

    giver.show();
    getter.show();

    return a.exec();
}
